package mki.xml2csv.access;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.StringTokenizer;

import mki.xml2csv.access.DomAccess;
//import mki.xml.model.XQueryConditionModel;
import mki.xqueryconstructor.core.XQueryConditionModel;
import mki.xml2csv.model.Xml2CsvConfigModel;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * `͗pNX
 * @author nagashima
 * @version 1.0
 */
public class Xml2CsvConfigXmlParse {
  private DomAccess dom = null;

  /**
   * RXgN^
   */
  public Xml2CsvConfigXmlParse() {
    try {
      dom = new DomAccess();
    }
    catch (Exception e) {
      System.out.println("e = " + e);
      //throw e;
    }
  }

  /**
   * w肳ꂽt@C`XMLt@CƂĉ͂Ē`񃂃fԂ
   *
   * @param definexml `XMLt@C
   * @throws Exception
   * @return Xml2CsvConfigModel
   */
  public Xml2CsvConfigModel parseFile(String definexml) throws Exception {
    //`ǂݍ
    Document doc = dom.parseFile(definexml);
    return getConfigModel(doc);
  }

  /**
   * w肳ꂽStringencodingĒ`XMLƂĉ͂Ē`񃂃fԂ
   *
   * @param data `XML
   * @param enc encoding
   * @throws Exception
   * @return Xml2CsvConfigModel
   */
  public Xml2CsvConfigModel parseString(String data, String enc) throws
      Exception {
    Xml2CsvConfigModel model = null;
    try {
      //`ǂݍ
      Document doc = dom.parseString(data, enc);
      model = getConfigModel(doc);
      return model;
    }
    catch (Exception e) {
      throw e;
    }
  }

  /**
   * w肳ꂽDOMDocument`XMLƂĉ͂Ē`񃂃fԂ
   *
   * @param doc DOMDocument
   * @throws Exception
   * @return Xml2CsvConfigModel
   */
  private Xml2CsvConfigModel getConfigModel(Document doc) throws Exception {
    Xml2CsvConfigModel model = null;
    String tmp = null;
    //`ǂݍ
    try {
      model = new Xml2CsvConfigModel();
      Element elmDefine = doc.getDocumentElement();

      //ID
      NodeList lstNode = elmDefine.getElementsByTagName("config");
      //NodeList lstNode = elmDefine.getElementsByTagName("xml2csv");
      Element elm = (Element) lstNode.item(0);
      //model.id = elm.getAttribute("id");
      model.setId(elm.getAttribute("id"));
      System.out.println("id = " + model.getId());
      //zXg
      //model.host = getTagValue(elmDefine, "host");
      model.setHost(getTagValue(elmDefine, "host"));
      System.out.println("host = " + model.getHost());
      //|[g
      String str = getTagValue(elmDefine, "port");
      //model.port = str;
      model.setPort(str);
      //model.port = Integer.parseInt(str);
      System.out.println("port = " + str);
      //[UID
      //model.userid = getTagValue(elmDefine, "userid");
      model.setUserid(getTagValue(elmDefine, "userid"));
      System.out.println("userid = " + model.getUserid());
      //pX[h
      //model.password = getTagValue(elmDefine, "password");
      model.setPassword(getTagValue(elmDefine, "password"));
      System.out.println("password = " + model.getPassword());
      //NG[
      //model.query = getTagValue(elmDefine, "query");
      model.setQuery(getTagValue(elmDefine, "query"));
      System.out.println("query = " + model.getQuery());
      //autocreatedquerytO
      String ac = getTagValue2(elmDefine, "autocreatedqueryflag");
      if (ac.equals("true")) {
        model.setAutoCreatedQueryFlag(true);
      }
      else {
        model.setAutoCreatedQueryFlag(false);
      }
      System.out.println("whereflag = " + ac);
      //wheretO
      String wf = getTagValue2(elmDefine, "whereflag");
      if (wf.equals("true")) {
        model.setWhereFlag(true);
      }
      else {
        model.setWhereFlag(false);
      }
      System.out.println("whereflag = " + wf);
      //hLg
      //model.document = getTagValue(elmDefine, "document");
      model.setDocument(getTagValue(elmDefine, "document"));
      System.out.println("document = " + model.getDocument());
      //R[h^O
      //model.strRecordTag = getTagValue(elmDefine, "recordtag");
      model.setStrRecordTag(getTagValue(elmDefine, "recordtag"));
      System.out.println("recordtag = " + model.getStrRecordTag());
      //CSVt@C
      model.setCsvfile(getTagValue2(elmDefine, "csvfile"));
      System.out.println("csvfile = " + model.getCsvfile());
      //CSV^Cv
      try {
        tmp = getTagValue(elmDefine, "csvtypeflag");
      }
      catch (Exception e) {
        tmp = "false";
      }
      model.typeFlag = false;
      if (tmp.equals("true")) {
        model.typeFlag = true;
      }
      System.out.println("model.typeFlag = " + model.typeFlag);
      //l
      model.setMemo(getTagValue2(elmDefine, "memo"));
      System.out.println("memo = " + model.getMemo());

      //XQuery
      NodeList lstCond = elmDefine.getElementsByTagName("condition");
      int numCond = lstCond.getLength();
      for (int m = 0; m < numCond; m++) {
        Element elmCond = (Element) lstCond.item(m);
        if (m == 0) {
          model.lstConditions = new ArrayList();
        }
        /*XQueryConditionModel qmodel = new XQueryConditionModel();
        qmodel.setAndor(getTagValue2(elmCond, "and_or"));
        qmodel.setNode(getTagValue2(elmCond, "node"));
        qmodel.setFunc(getTagValue2(elmCond, "func"));
        qmodel.setEq(getTagValue2(elmCond, "eq"));
        qmodel.setValue(getTagValue2(elmCond, "value"));*/
        XQueryConditionModel qmodel = new XQueryConditionModel(getTagValue2(elmCond, "and_or"),
            getTagValue2(elmCond, "node"),
            getTagValue2(elmCond, "func"),
            getTagValue2(elmCond, "eq"),
            getTagValue2(elmCond, "value"));

        model.lstConditions.add(qmodel);
      }

      //tB[h
      NodeList lstField = elmDefine.getElementsByTagName("field");
      //System.out.println("csvfile3 = " + csvfile);
      int numField = lstField.getLength();
      //System.out.println("tB[h = " + numField);
      //String[] field = {"brand@name","model@name","model@technology","height","width","thickness","weight","battery","talk-time","standby-time"};
      //field = new String[numField];
      //csvfield = new String[numField];
      for (int m = 0; m < numField; m++) {
        Element elmField = (Element) lstField.item(m);
        if (m == 0)
          model.lstFields = new ArrayList();
          //String[] field = new String[3];
        String[] field = new String[4];
        field[0] = getTagValue(elmField, "xmltag");
        try {
          //field[1] =
          //  String.valueOf(
          //    Integer.parseInt(getTagValue(elmField, "index")));
          field[1] = getTagValue(elmField, "index");
        }
        catch (Exception ex) {
          field[1] = "";
          //field[1] = "1";
        }
        field[2] = getTagValue(elmField, "csvfield");
        try {
          field[3] = getTagValue(elmField, "csvtype");
        }
        catch (Exception ex) {
          field[3] = "";
        }
        model.lstFields.add(field);
      }
      //}`IJX
      try {
        model.multioccurrence =
            getTagValue(elmDefine, "multioccurrence");
        model.mapMulti = new HashMap();
        StringTokenizer st =
            new StringTokenizer(model.multioccurrence, ",");
        while (st.hasMoreTokens()) {
          String mult = st.nextToken();
          List lstMulti = new ArrayList();
          Iterator it = model.lstFields.iterator();
          while (it.hasNext()) {
            String[] ary = (String[]) it.next();
            if (ary[0].startsWith(mult)) {
              lstMulti.add(ary[0]);
              //System.out.println("ary[0]:" + ary[0]);
              //System.out.println("mult:" + mult);
            }
          }
          int a = 0;
          String[] strArray = new String[lstMulti.size()];
          Iterator itMulti = lstMulti.iterator();
          while (itMulti.hasNext()) {
            strArray[a] = (String) itMulti.next();
            a++;
          }
          model.mapMulti.put(mult, strArray);
        }

      }
      catch (Exception e) {
        //e.printStackTrace();
        //System.out.println("e=" + e);
      }
      if (model.multioccurrence != null
          && model.multioccurrence.equals("")) {
        model.multioccurrence = null;
      }
      System.out.println("multioccurrence = " + model.multioccurrence);
      return model;
    }
    catch (Exception e) {
      System.out.println("`t@Csł:" + e);
      model = null;
      throw new Exception("`t@Csł");
    }
  }

  /**
   * w肳ꂽElement̎q̎w肳ꂽ^O̗vf̒lԂB^O݂ȂꍇExceptionB
   *
   * @param element Gg
   * @param name ^O
   * @return l
   */
  private String getTagValue(Element element, String name) {
    NodeList lstNode = element.getElementsByTagName(name);
    Element elm = (Element) lstNode.item(0);
    return elm.getChildNodes().item(0).getNodeValue();
  }

  /**
   * w肳ꂽElement̎q̎w肳ꂽ^O̗vf̒lԂB^O݂Ȃ""Ԃ
   *
   * @param element Gg
   * @param name ^O
   * @return l
   */
  private String getTagValue2(Element element, String name) {
    String result = "";
    try {
      result = getTagValue(element, name);
    }
    catch (Exception e) {
      //System.out.println("e=" + e);
    }
    return result;
  }
}
